﻿Imports System.Net
Imports System.Web
Imports System.IO

Public Class Program
   Public Shared Sub Main(ParamArray args() As String)
      Console.WriteLine("Video ID")

#If True Then  'alternative Test-Eingaben - nur die erste ist gültig
      Dim id = "eMVNjMF1Suo" ' gültig, zumindest am 16.9.20015
#ElseIf True Then
      Dim id = "LLuZl-0Pjuo" ' ungültig, da dieses Video Einbettungen nicht zulässt
#ElseIf True Then
      Dim id = Console.ReadLine()  ' benutzer-Eingabe
#ElseIf True Then
#End If

      Dim utubeUrl = "https://www.youtube.com/watch?v=" & id
      Dim client = New WebClient()
      Dim uri = "http://youtube.com/get_video_info?&video_id=" & id
      Dim raw_video_info = client.DownloadString(uri)
      Dim rawAllData = ToStringTable(raw_video_info).ToDictionary(Function(entry) entry(0), Function(entry) entry(1))
      Dim rawStream_map = HttpUtility.UrlDecode(rawAllData("url_encoded_fmt_stream_map"))
      Dim streamInfos = rawStream_map.Split(","c).[Select](Function(data) StreamInfo.FromStringTable(ToStringTable(data))).ToArray()
      Console.WriteLine(String.Join(Lf, streamInfos.[Select](Function(inf, i) i.ToString() & ") " & Convert.ToString(inf.Type) & " " & Convert.ToString(inf.Quality))))
      Console.WriteLine("Choose an Index")
      Dim index = 0
      If Integer.TryParse(Console.ReadLine(), index) Then
         Dim info = streamInfos(index)
         Dim fileName = ValidFileName(HttpUtility.UrlDecode(rawAllData("title"))) & "." & info.GetFileType
         Console.WriteLine("Download video to{0}{1}", Lf, fileName)
         client.DownloadFile(info.GetDownloadUrl(), fileName)  'hier kann testweise Haltepunkt gesetzt werden, um dann den Download auszulassen
      End If
   End Sub
   Private Shared Function ToStringTable(s As String) As IEnumerable(Of String())
      Return s.Split("&"c).[Select](Function(entry) entry.Split("="c))
   End Function
   Private Shared Function ValidFileName(s As String) As String
      Return String.Join("-", s.Split(Path.GetInvalidFileNameChars(), StringSplitOptions.None))
   End Function
End Class

Public Class StreamInfo
   Public Shared Function FromStringTable(table As IEnumerable(Of String())) As StreamInfo
      Dim info As New StreamInfo()
      Dim infoType As Type = GetType(StreamInfo)
      Dim properties = infoType.GetProperties().ToDictionary(Function(item) item.Name.ToLower())
      For Each entry In table
         properties(entry(0).ToLower()).SetValue(info, Convert.ChangeType(entry(1), properties(entry(0).ToLower()).PropertyType))
      Next
      Return info
   End Function
   Public Property Url() As String
   Public Property Fallback_Host() As String
   Public Property ITag() As Integer
   Public Property Quality() As String
   Public Property Sig() As String
   Public Property Type() As String
   Public Function GetFileType() As String
      Return HttpUtility.UrlDecode(Type).Split(";"c)(0).Split("/"c)(1).Replace("x-", "")
   End Function
   Public Function GetDownloadUrl() As String
      Return String.Format("{0}&fallback_host={1}&signature={2}", HttpUtility.UrlDecode(Url), Fallback_Host, Sig)
   End Function
End Class

